﻿/*
* 林飞
* 修改时间: 2012/05/12
* http://www.5imvc.com/Rep/Map
*博客：http://www.cnblogs.com/linfei721/
*代码：http://www.cnblogs.com/linfei721/archive/2013/06/02/3114174.html
*/
$(document).ready(function () {

    Map();

    showTips();
});

function Map() {
    /*
    * 配置Raphael生成svg的属性
    */
    $("#map").html("");
    Raphael.getColor.reset();
    var R = Raphael("map", 650, 500); //大小与矢量图形文件图形对应；

    var current = null;

    var textAttr = {
        "fill": "#000",
        "font-size": "12px",
        "cursor": "pointer"
    };

    //调用绘制地图方法
    paintMap(R);

    for (var state in china) {
        //分省区域着色
        china[state]['path'].color = Raphael.getColor(0.9);
        //china[state]['path'].animate({fill: china[state]['path'].color, stroke: "#eee" }, 500);
        china[state]['path'].transform("t30,0");

        (function (st, state) {
            //***获取当前图形的中心坐标
            var xx = st.getBBox().x + (st.getBBox().width / 2);
            var yy = st.getBBox().y + (st.getBBox().height / 2);

            //***修改部分地图文字偏移坐标
            switch (china[state]['name']) {
                case "江苏":
                    xx += 5;
                    yy -= 10;
                    break;
                case "河北":
                    xx -= 10;
                    yy += 20;
                    break;
                case "天津":
                    xx += 20;
                    yy += 10;
                    break;
                case "上海":
                    xx += 20;
                    break;
                case "广东":
                    yy -= 10;
                    break;
                case "澳门":
                    yy += 10;
                    break;
                case "香港":
                    xx += 20;
                    yy += 5;
                    break;
                case "甘肃":
                    xx -= 40;
                    yy -= 30;
                    break;
                case "陕西":
                    xx += 5;
                    yy += 20;
                    break;
                case "内蒙古":
                    xx -= 15;
                    yy += 65;
                    break;
                default:
            }


            //***写入地名,并加点击事件,部分区域太小，增加对文字的点击事件
            china[state]['text'] = R.text(xx, yy, china[state]['name']).attr(textAttr).click(function () {
                clickMap();
            }).hover(function () {
                var $sl = $("#topList").find("[title='" + china[state]['name'] + "']:not([select])");
                $sl.css("font-size", "20px");
            }, function () {
                var $sl = $("#topList").find("[title='" + china[state]['name'] + "']:not([select])");
                $sl.css("font-size", "");
            });

            //图形的点击事件
            $(st[0]).click(function (e) {
                clickMap();
            });
            //鼠标样式
            $(st[0]).css('cursor', 'pointer');

            function clickMap() {
                if (current == state)
                    return;
                //重置上次点击的图形
                current && china[current]['path'].animate({ transform: "t30,0", fill: china[current]['isClick'] ? china[current]['path'].color : "#b0d0ec", stroke: "#ddd" }, 2000, "elastic");

                current = state;    //将当前值赋给变量
                //对本次点击
                china[state]['path'].animate({ transform: "t30,0 s1.03 1.03", fill: china[state]['path'].color, stroke: "#000" }, 1200, "elastic");
                st.toFront();   //向上
                R.safari();

                china[current]['text'].toFront();   //***向上

                window.control.onProvinceChanged(china[current]['name'],china[current]['spell'])
            }
        })

        (china[state]['path'], state);
    }
}

function showTips(){
    var tips = $('#tips');
    tips.html('中国疆域宽广，一般分为七大地理地区：<br><br>1、华东：上海、江苏、浙江、安徽、福建、江西、山东、台湾<br>2、华北：北京、天津、山西、河北、内蒙古<br>3、华中：河南、湖北、湖南<br>4、华南：广东、广西、海南、香港、澳门<br>5、西南：四川、贵州、云南、重庆、西藏<br>6、西北：陕西、甘肃、青海、宁夏、新疆、内蒙古西部<br>7、东北：黑龙江、吉林、辽宁、内蒙古东部<br><br><br>提示：对于面积较小的区域则可以点击区域的名称（如香港、澳门）。').delay(1500).fadeIn('slow');
}


